diff -crN nakedmudv1.0/src/olc/olc.h nakedmudv1.4/src/olc/olc.h
*** nakedmudv1.0/src/olc/olc.h	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.4/src/olc/olc.h	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,213 ----
+ #ifndef __OLC_H
+ #define __OLC_H
+ //*****************************************************************************
+ //
+ // olc.h
+ //
+ // Contains all of the functions neccessary for online editing.
+ //
+ //*****************************************************************************
+ 
+ #define OLC_AUTOSAVE                (TRUE)
+ 
+ COMMAND(cmd_oedit);  // object editing
+ COMMAND(cmd_medit);  // mobile editing
+ COMMAND(cmd_redit);  // room editing
+ COMMAND(cmd_zedit);  // zone editing
+ COMMAND(cmd_wedit);  // world editing
+ COMMAND(cmd_dedit);  // dialog editing
+ #ifdef MODULE_SCRIPTS
+ COMMAND(cmd_scedit); // script editing
+ #endif
+ #ifdef MODULE_SOCIALS
+ COMMAND(cmd_socedit); // social editing
+ #endif
+ 
+ // initialize OLC. Must be called when the MUD starts up
+ void init_olc();
+ 
+ // enter the olc loop with the specified argument and olc data
+ void olc_loop(SOCKET_DATA *sock, char *arg);
+ void olc_menu(SOCKET_DATA *sock);
+ 
+ 
+ //
+ // writes the reset info to a buffer and returns it. 
+ // This is used by redit and resedit. If indent_first is false, the first
+ // line is not indented. This can be useful for displaying menus.
+ //
+ const char *write_reset(RESET_DATA *reset, int indent, bool indent_first);
+ 
+ 
+ //*****************************************************************************
+ //
+ // olc datastructure
+ //
+ // contains all of the information about what a socket is currently editing
+ //
+ //*****************************************************************************
+ #define OLC_MAIN                 0 // general OLC menu
+ #define OLC_REDIT                1 // room edit
+ #define OLC_ZEDIT                2 // zone edit
+ #define OLC_WEDIT                3 // world edit
+ #define OLC_EXEDIT               4 // exit edit
+ #define OLC_EDSEDIT              5 // edesc set edit
+ #define OLC_EDEDIT               6 // edesc edit
+ #define OLC_MEDIT                7 // mobile editing
+ #define OLC_OEDIT                8 // object editing
+ #define OLC_SCEDIT               9 // script editing
+ #define OLC_SSEDIT              10 // script set editing
+ #define OLC_DEDIT               11 // dialog editing
+ #define OLC_RESPEDIT            12 // dialog response editing
+ #define OLC_RESEDIT             13 // room reset editing
+ #define OLC_SOCEDIT             14 // social editing
+ 
+ #define ZEDIT_MAIN               0
+ #define ZEDIT_CONFIRM_SAVE       1
+ #define ZEDIT_NAME               2
+ #define ZEDIT_EDITORS            3
+ #define ZEDIT_MIN                4
+ #define ZEDIT_MAX                5
+ #define ZEDIT_RESET              6
+ 
+ #define SSEDIT_MAIN              0
+ #define SSEDIT_CONFIRM_SAVE      1
+ #define SSEDIT_ADD               2
+ #define SSEDIT_REMOVE            4
+ 
+ #define SCEDIT_MAIN              0
+ #define SCEDIT_CONFIRM_SAVE      1
+ #define SCEDIT_NAME              2
+ #define SCEDIT_TYPE              3
+ #define SCEDIT_ARGS              4
+ #define SCEDIT_NARG              5
+ 
+ #define OEDIT_MAIN               0
+ #define OEDIT_CONFIRM_SAVE       1
+ #define OEDIT_NAME               2
+ #define OEDIT_KEYWORDS           3
+ #define OEDIT_RDESC              4
+ #define OEDIT_EDESCS             5
+ #define OEDIT_TYPE               6
+ #define OEDIT_SUBTYPE            7
+ #define OEDIT_SCRIPTS            8
+ #define OEDIT_BITS               9
+ #define OEDIT_MULTI_NAME        10
+ #define OEDIT_MULTI_RDESC       11
+ #define OEDIT_WEIGHT            12
+ #define OEDIT_CAPACITY          13
+ 
+ #define OEDIT_VAL_0             20
+ #define OEDIT_VAL_1             21
+ #define OEDIT_VAL_2             22
+ #define OEDIT_VAL_3             23
+ 
+ #define MEDIT_MAIN               0
+ #define MEDIT_CONFIRM_SAVE       1
+ #define MEDIT_NAME               2
+ #define MEDIT_KEYWORDS           3
+ #define MEDIT_RDESC              4
+ #define MEDIT_SEX                5
+ #define MEDIT_DIALOG             6
+ #define MEDIT_RACE               7
+ #define MEDIT_SCRIPTS            8
+ #define MEDIT_MULTI_NAME         9
+ #define MEDIT_MULTI_RDESC       10
+ 
+ #define REDIT_MAIN               0
+ #define REDIT_CONFIRM_SAVE       1
+ #define REDIT_NAME               2
+ #define REDIT_CHOOSE_EXIT        3
+ #define REDIT_EXIT               4
+ #define REDIT_TERRAIN            5
+ #define REDIT_EDESCS             6
+ #define REDIT_SCRIPTS            7
+ #define REDIT_RESET              8
+ #define REDIT_DELETE_RESET       9
+ #define REDIT_EDIT_RESET        10
+ 
+ #define RESEDIT_MAIN             0
+ #define RESEDIT_CONFIRM_SAVE     1
+ #define RESEDIT_TYPE             2
+ #define RESEDIT_TIMES            3
+ #define RESEDIT_CHANCE           4
+ #define RESEDIT_MAX              5
+ #define RESEDIT_ROOM_MAX         6
+ #define RESEDIT_ARG              7
+ #define RESEDIT_IN               8
+ #define RESEDIT_ON               9
+ #define RESEDIT_THEN            10
+ #define RESEDIT_EDIT_IN         11
+ #define RESEDIT_EDIT_ON         12
+ #define RESEDIT_EDIT_THEN       13
+ #define RESEDIT_DELETE_IN       14
+ #define RESEDIT_DELETE_ON       15
+ #define RESEDIT_DELETE_THEN     16
+ 
+ #define EDSEDIT_MAIN             0
+ #define EDSEDIT_CONFIRM_SAVE     1
+ #define EDSEDIT_ENTRY            2
+ #define EDSEDIT_DELETE           3
+ 
+ #define EDEDIT_MAIN              0
+ #define EDEDIT_CONFIRM_SAVE      1
+ #define EDEDIT_KEYWORDS          2
+ 
+ #define DEDIT_MAIN               0
+ #define DEDIT_CONFIRM_SAVE       1
+ #define DEDIT_NAME               2
+ #define DEDIT_GREET              3
+ #define DEDIT_ENTRY              4
+ #define DEDIT_DELETE             5
+ 
+ #define RESPEDIT_MAIN            0
+ #define RESPEDIT_CONFIRM_SAVE    1
+ #define RESPEDIT_KEYWORDS        2
+ #define RESPEDIT_MESSAGE         3
+ 
+ #define EXEDIT_MAIN              0
+ #define EXEDIT_CONFIRM_SAVE      1
+ #define EXEDIT_TO                2
+ #define EXEDIT_SPOT_DIFF         3
+ #define EXEDIT_PICK_DIFF         4
+ #define EXEDIT_KEY               5
+ #define EXEDIT_CLOSABLE          6
+ #define EXEDIT_LEAVE             7
+ #define EXEDIT_ENTER             8
+ #define EXEDIT_CONFIRM_DELETE    9
+ #define EXEDIT_NAME             10
+ #define EXEDIT_KEYWORDS         11
+ 
+ #define SOCEDIT_MAIN             0
+ #define SOCEDIT_CONFIRM_SAVE     1
+ #define SOCEDIT_CHAR_NOTGT       2
+ #define SOCEDIT_ROOM_NOTGT       3
+ #define SOCEDIT_CHAR_SELF        4
+ #define SOCEDIT_ROOM_SELF        5
+ #define SOCEDIT_CHAR_TGT         6
+ #define SOCEDIT_VICT_TGT         7
+ #define SOCEDIT_ROOM_TGT         8
+ #define SOCEDIT_MIN_POS          9
+ #define SOCEDIT_MAX_POS         10
+ 
+ 
+ OLC_DATA   *newOLC        (int state, int substate, void *data,const char *arg);
+ void        deleteOLC     (OLC_DATA *olc);
+ 
+ bool        isOLCComplete (OLC_DATA *olc);
+ bool        olcGetSave    (OLC_DATA *olc);
+ int         olcGetState   (OLC_DATA *olc);
+ int         olcGetSubstate(OLC_DATA *olc);
+ void       *olcGetData    (OLC_DATA *olc);
+ const char *olcGetArgument(OLC_DATA *olc);
+ OLC_DATA   *olcGetNext    (OLC_DATA *olc);
+ 
+ void        olcSetSave    (OLC_DATA *olc, bool save);
+ void        olcSetData    (OLC_DATA *olc, void  *data);
+ void        olcSetArgument(OLC_DATA *olc, char *arg);
+ void        olcSetState   (OLC_DATA *olc, int state);
+ void        olcSetSubstate(OLC_DATA *olc, int substate);
+ void        olcSetNext    (OLC_DATA *olc, OLC_DATA *next);
+ void        olcSetComplete(OLC_DATA *olc, bool complete);
+ 
+ #endif // __OLC_H
diff -crN nakedmudv1.0/src/olc/redit.c nakedmudv1.4/src/olc/redit.c
*** nakedmudv1.0/src/olc/redit.c	1969-12-31 18:00:00.000000000 -0600
--- nakedmudv1.4/src/olc/redit.c	2010-11-01 15:54:18.000000000 -0500
***************
*** 0 ****
--- 1,461 ----
+ //*****************************************************************************
+ //
+ // redit.c
+ //
+ // Contains all of the functions needed for online editing of rooms.
+ //
+ //*****************************************************************************
+ 
+ #include "../mud.h"
+ #include "../world.h"
+ #include "../room.h"
+ #include "../exit.h"
+ #include "../room_reset.h"
+ #include "../extra_descs.h"
+ #include "../socket.h"
+ #include "../utils.h"
+ 
+ #include "olc.h"
+ 
+ #ifdef MODULE_SCRIPTS
+ #include "../scripts/script_set.h"
+ #include "../scripts/script.h"
+ #endif
+ #ifdef MODULE_TIME
+ #include "../time/mudtime.h"
+ #endif
+ 
+ // if we're in the reset menu and we want to make
+ // a new entry, this needs to be used, instead of
+ // the position in the list the entry is
+ #define EDITING_NEW_RESET  "new_reset"
+ 
+ 
+ //
+ // Display a list of available terrains
+ //
+ void redit_terrain_menu(SOCKET_DATA *sock) {
+   int i;
+ 
+   for(i = 0; i < NUM_TERRAINS; i++)
+     send_to_socket(sock, "  {c%2d{y) {g%-15s%s",
+ 		   i, terrainGetName(i), (i % 3 == 2 ? "\r\n" : "    "));
+ 
+   if(i % 3 != 0)
+     send_to_socket(sock, "\r\n");
+ }
+ 
+ 
+ //
+ // display the room reset menu to the character
+ //
+ void redit_reset_menu(SOCKET_DATA *sock, OLC_DATA *olc) {
+   LIST *list           = roomGetResets(olcGetData(olc));
+   LIST_ITERATOR *res_i = newListIterator(list);
+   RESET_DATA    *reset = NULL;
+   int count = 0;
+ 
+   send_to_socket(sock,
+                  "\033[H\033[J"
+ 		 "{wCurrent reset commands:\r\n");
+ 
+   while( (reset = listIteratorCurrent(res_i)) != NULL) {
+     listIteratorNext(res_i);
+     send_to_socket(sock, " {g%2d) %s", count, write_reset(reset, 5, FALSE));
+     count++;
+   }
+   deleteListIterator(res_i);
+ 
+   send_to_socket(sock,
+ 		 "\r\n"
+ 		 "  {gN) new entry\r\n"
+ 		 "  D) delete entry\r\n"
+ 		 "  Use number to edit specific entry\r\n"
+ 		 "\r\n"
+ 		 "{gEnter choice (Q to quit) : {n"
+ 		 );
+ }
+ 
+ 
+ //
+ // Display the exits the socket can edit
+ //
+ void redit_exit_menu(SOCKET_DATA *sock, OLC_DATA *olc) {
+   int i;
+   ROOM_DATA *room = (ROOM_DATA *)olcGetData(olc);
+ 
+   // normal exits first
+   for(i = 0; i < NUM_DIRS; i++) {
+     EXIT_DATA *exit = roomGetExit(room, i);
+     send_to_socket(sock, "   {g%-10s : {y[%s%6d{y]%s",
+ 		   dirGetName(i), 
+ 		   (exit ? "{c" : "{y" ),
+ 		   (exit ? exitGetTo(exit) : -1),
+ 		   (!(i % 2) ? "   " : "\r\n"));
+   }
+ 
+   // now special exits
+   int num_spec_exits = 0;
+   char **room_names = roomGetExitNames(room, &num_spec_exits);
+   for(i = 0; i < num_spec_exits; i++) {
+     EXIT_DATA *exit = roomGetExitSpecial(room, room_names[i]);
+     send_to_socket(sock, "   {g%-10s : {y[{c%6d{y]%s",
+ 		   room_names[i],
+ 		   exitGetTo(exit),
+ 		   (!(i % 2) ? "   " : "\r\n"));
+   }
+ 
+   // make sure we've printed the last newline if needed
+   if(i % 2 == 1)
+     send_to_socket(sock, "\r\n");
+ 
+   // clean up our mess
+   for(i = 0; i < num_spec_exits; i++)
+     free(room_names[i]);
+   free(room_names);
+ }
+ 
+ 
+ void redit_menu(SOCKET_DATA *sock, OLC_DATA *olc) {
+   ROOM_DATA *room = (ROOM_DATA *)olcGetData(olc);
+ 
+   send_to_socket(sock,
+                  "\033[H\033[J"
+ 		 "{g[{c%d{g]\r\n"
+ 		 "{g1) Name\r\n"
+ 		 "{c%s\r\n"
+ 		 "{g2) Description\r\n"
+ 		 "{c%s\r\n"
+ #ifdef MODULE_TIME
+ 		 "{g3) Night Description (optional)\r\n"
+ 		 "{c%s\r\n"
+ #endif
+ 		 "{gT) Terrain type {y[{c%s{y]\r\n"
+ 		 "{gX) Extra descriptions menu\r\n"
+ 		 "{gR) Reset menu\r\n"
+ #ifdef MODULE_SCRIPTS
+ 		 "{gS) Script menu\r\n"
+ #endif
+ 		 "{gE) Exit menu\r\n",
+ 		 roomGetVnum(room),
+ 		 roomGetName(room),
+ 		 roomGetDesc(room),
+ #ifdef MODULE_TIME
+ 		 roomGetNightDesc(room),
+ #endif
+ 		 terrainGetName(roomGetTerrain(room))
+ 		 );
+ 
+   redit_exit_menu(sock, olc);
+   send_to_socket(sock,
+ 		 "\r\n"
+ 		 "{gEnter choice (Q to quit) : {n"
+ 		 );
+ }
+ 
+ 
+ //
+ // the room reset main loop
+ //
+ void redit_reset_loop(SOCKET_DATA *sock, OLC_DATA *olc, char *arg) {
+   int next_substate = REDIT_RESET;
+ 
+   switch(toupper(*arg)) {
+   case 'Q':
+     next_substate = REDIT_MAIN;
+     break;
+ 
+   case 'N':
+     olcSetNext(olc, newOLC(OLC_RESEDIT, RESEDIT_MAIN,
+ 			   newReset(), strdup(EDITING_NEW_RESET)));
+     next_substate = REDIT_EDIT_RESET;
+     break;
+ 
+   case 'D':
+     next_substate = REDIT_DELETE_RESET;
+     send_to_socket(sock, "Which entry would you like to delete : ");
+     break;
+ 
+   default:
+     // see if maybe they're trying to choose a description to edit
+     if(!isdigit(*arg))
+       redit_reset_menu(sock, olc);
+     else {
+       int num = atoi(arg);
+       RESET_DATA *reset = listGet(roomGetResets(olcGetData(olc)), num);
+       // if the one found is null, just show the menu
+       if(reset == NULL)
+ 	redit_reset_menu(sock, olc);
+       else {
+ 	olcSetNext(olc, newOLC(OLC_RESEDIT, RESEDIT_MAIN, 
+ 			       resetCopy(reset), strdup(arg)));
+ 	next_substate = REDIT_EDIT_RESET;
+ 	break;
+       }
+     }
+     break;
+   }
+ 
+   olcSetSubstate(olc, next_substate);
+   if(next_substate == REDIT_MAIN)
+     redit_menu(sock, olc);
+ }
+ 
+ 
+ 
+ //
+ // The main loop for editing rooms
+ //
+ void redit_main_loop(SOCKET_DATA *sock, OLC_DATA *olc, char *arg) {
+   int next_substate = REDIT_MAIN;
+ 
+   switch(toupper(*arg)) {
+   case 'Q':
+     send_to_socket(sock, "Save changes (Y/N) : ");
+     next_substate = REDIT_CONFIRM_SAVE;
+     break;
+ 
+   case '1':
+     send_to_socket(sock, "Enter new name : ");
+     next_substate = REDIT_NAME;
+     break;
+ 
+   case '2':
+     send_to_socket(sock, "Enter new description\r\n");
+     start_text_editor(sock, 
+ 		      roomGetDescPtr((ROOM_DATA *)olcGetData(olc)),
+ 		      MAX_BUFFER, EDITOR_MODE_NORMAL);
+     next_substate = REDIT_MAIN;
+     break;
+ 
+   case 'T':
+     redit_terrain_menu(sock);
+     send_to_socket(sock, "Pick a new terrain number : ");
+     next_substate = REDIT_TERRAIN;
+     break;
+ 
+   case 'R':
+     redit_reset_menu(sock, olc);
+     next_substate = REDIT_RESET;
+     break;
+ 
+   case 'E':
+     send_to_socket(sock, "Which exit do you want to edit : ");
+     next_substate = REDIT_CHOOSE_EXIT;
+     break;
+ 
+   case 'X':
+     olcSetNext(olc, newOLC(OLC_EDSEDIT, EDSEDIT_MAIN, 
+ 			   copyEdescSet(roomGetEdescs((ROOM_DATA *)olcGetData(olc))), NULL));
+     next_substate = REDIT_EDESCS;
+     break;
+ 
+ #ifdef MODULE_SCRIPTS
+   case 's':
+   case 'S':
+     olcSetNext(olc, newOLC(OLC_SSEDIT, SSEDIT_MAIN,
+ 			   copyScriptSet(roomGetScripts((ROOM_DATA *)olcGetData(olc))), roomGetName((ROOM_DATA *)olcGetData(olc))));
+     next_substate = REDIT_SCRIPTS;
+     break;
+ #endif
+ 
+ #ifdef MODULE_TIME
+   case '3':
+     send_to_socket(sock, "Enter new description\r\n");
+     start_text_editor(sock, 
+ 		      roomGetNightDescPtr((ROOM_DATA *)olcGetData(olc)),
+ 		      MAX_BUFFER, EDITOR_MODE_NORMAL);
+     next_substate = REDIT_MAIN;
+     break;
+ #endif
+ 
+   default:
+     redit_menu(sock, olc);
+     break;
+   }
+ 
+   olcSetSubstate(olc, next_substate);
+ }
+ 
+ 
+ 
+ //
+ // The entry loop for redit. Figures out what substate we're
+ // in, and then enters into the appropriate subloop if possible,
+ // or sets a value based on arg if there is no subloop
+ //
+ void redit_loop(SOCKET_DATA *sock, OLC_DATA *olc, char *arg) {
+   ROOM_DATA *room = (ROOM_DATA *)olcGetData(olc);
+   int next_substate = REDIT_MAIN;
+ 
+   switch(olcGetSubstate(olc)) {
+     /******************************************************/
+     /*                     MAIN MENU                      */
+     /******************************************************/
+   case REDIT_MAIN:
+     redit_main_loop(sock, olc, arg);
+     return;
+ 
+   case REDIT_RESET:
+     redit_reset_loop(sock, olc, arg);
+     return;
+ 
+     /******************************************************/
+     /*                    CONFIRM SAVE                    */
+     /******************************************************/
+   case REDIT_CONFIRM_SAVE:
+     switch(*arg) {
+     case 'y':
+     case 'Y':
+       olcSetSave(olc, TRUE);
+       // fall through
+     case 'n':
+     case 'N':
+       olcSetComplete(olc, TRUE);
+       return;
+     default:
+       send_to_socket(sock, "Please enter Y or N : ");
+       next_substate = REDIT_CONFIRM_SAVE;
+       break;
+     }
+     break;
+ 
+ 
+     /******************************************************/
+     /*                      SET VALUES                    */
+     /******************************************************/
+   case REDIT_NAME:
+     roomSetName(room, arg);
+     break;
+   case REDIT_TERRAIN:
+     roomSetTerrain(room, 
+ 		   MIN(NUM_TERRAINS - 1,
+ 		       MAX(TERRAIN_NONE + 1, atoi(arg))));
+     break;
+ 
+   case REDIT_EDESCS:
+     // save the changes we made
+     if(olcGetSave(olcGetNext(olc))) {
+       EDESC_SET *edescs = (EDESC_SET *)olcGetData(olcGetNext(olc));
+       roomSetEdescs(room, (edescs ? copyEdescSet(edescs) : newEdescSet()));
+     }
+ 
+     olcSetNext(olc, NULL);
+     next_substate = REDIT_MAIN;
+     break;
+ 
+ #ifdef MODULE_SCRIPTS
+   case REDIT_SCRIPTS:
+     // save the changes we made
+     if(olcGetSave(olcGetNext(olc))) {
+       SCRIPT_SET *scripts = (SCRIPT_SET *)olcGetData(olcGetNext(olc));
+       roomSetScripts(room, (scripts ? copyScriptSet(scripts) : newScriptSet()));
+     }
+     olcSetNext(olc, NULL);
+     next_substate = REDIT_MAIN;
+     break;
+ #endif
+ 
+ 
+     /******************************************************/
+     /*                    RESET EDITOR                    */
+     /******************************************************/
+   case REDIT_DELETE_RESET: {
+     RESET_DATA *reset = (isdigit(*arg)? listGet(roomGetResets(room),atoi(arg)) :
+ 			 NULL);
+     if(reset != NULL) {
+       listRemove(roomGetResets(room), reset);
+       deleteReset(reset);
+     }
+     next_substate = REDIT_RESET;
+     break;
+   }
+ 
+   case REDIT_EDIT_RESET: {
+     // save the changes we made
+     if(olcGetSave(olcGetNext(olc))) {
+       RESET_DATA *reset = olcGetData(olcGetNext(olc));
+       if(!strcmp(EDITING_NEW_RESET, olcGetArgument(olcGetNext(olc))))
+ 	listQueue(roomGetResets(room), resetCopy(reset));
+       else {
+ 	int num = atoi(olcGetArgument(olcGetNext(olc)));
+ 	resetCopyTo(reset, listGet(roomGetResets(room), num));
+       }
+     }
+     next_substate = REDIT_RESET;
+     break;
+   }
+ 
+ 
+     /******************************************************/
+     /*                     EXIT EDITOR                    */
+     /******************************************************/
+   case REDIT_EXIT: {
+     // save the changes we made
+     if(olcGetSave(olcGetNext(olc))) {
+       EXIT_DATA *exit = (EXIT_DATA *)olcGetData(olcGetNext(olc));
+       const char *dirName = olcGetArgument(olcGetNext(olc));
+       int dir = dirGetNum(dirName);
+       // special exit
+       if(dir == DIR_NONE)
+ 	roomSetExitSpecial(room, dirName, (exit ? exitCopy(exit) : NULL));
+       // normal dir
+       else
+ 	roomSetExit(room, dir, (exit ? exitCopy(exit) : NULL));
+     }
+ 
+     olcSetNext(olc, NULL);
+     next_substate = REDIT_MAIN;
+     break;
+   }
+ 
+   case REDIT_CHOOSE_EXIT: {
+     EXIT_DATA *exit = NULL;
+     int dir = dirGetNum(arg);
+     char *dirName = NULL;
+ 
+     if(dir == DIR_NONE)
+       dir = dirGetAbbrevNum(arg);
+ 
+     // find the exit we're editing
+     if(dir != DIR_NONE) {
+       if(roomGetExit((ROOM_DATA *)olcGetData(olc), dir))
+ 	exit = exitCopy(roomGetExit((ROOM_DATA *)olcGetData(olc), dir));
+       dirName = strdup(dirGetName(dir));
+     }
+     else if(roomGetExitSpecial((ROOM_DATA *)olcGetData(olc), arg)) {
+       if(roomGetExitSpecial((ROOM_DATA *)olcGetData(olc), arg))
+ 	exit = exitCopy(roomGetExitSpecial((ROOM_DATA *)olcGetData(olc), arg));
+       dirName = strdup(arg);
+     }
+     else
+       dirName = strdup(arg);
+ 
+     // if the exit didn't exist already, create it
+     if(exit == NULL)
+       exit = newExit();
+ 
+     olcSetNext(olc, newOLC(OLC_EXEDIT, EXEDIT_MAIN, exit, dirName));
+     next_substate = REDIT_EXIT;
+     free(dirName);
+     break;
+   }
+ 
+ 
+     /******************************************************/
+     /*                        DEFAULT                     */
+     /******************************************************/
+   default:
+     log_string("ERROR: Performing redit with invalid substate.");
+     send_to_socket(sock, "An error occured while you were in OLC.\r\n");
+     socketSetOLC(sock, NULL);
+     socketSetState(sock, STATE_PLAYING);
+     return;
+   }
+ 
+   olcSetSubstate(olc, next_substate);
+   if(next_substate == REDIT_MAIN)
+     redit_menu(sock, olc);
+   else if(next_substate == REDIT_RESET)
+     redit_reset_menu(sock, olc);
+ }
